@ECHO OFF

REM ========================================================================================================================================================
	REM 	DateTimeExpanded.cmd - Call on GetDate.cmd, jDate.cmd, gdate.cmd and GetTime.cmd use input variables dmod and Searchday
	REM	GetDate.cmd ---------- Pull the current Day, Month, and Year
	REM	jDate.cmd ------------ Converts the GetDate.cmd values into a Julian Number
	REM 	gdate.cmd ------------ Converts the Julian number back into Day, Month, Year
	REM	SubtractDay ---------- Pulled in variable used to select the number of days to be subtracted from the julian number
	REM 	SearchDay ------------ Pulled in variable used to select a previous day of the week and subtract from the julian number
	REM	ExactDay ------------- Pulled in TWO DIGIT variable used to select exact day of the month
	REM	OVERRIDE ------------- Pulled in variable used to override the current date and affect all following date values

	REM Date EXAMPLE
		REM SET SubtractDay=1 - This would set the Previous variables to yesterday (NONE) will skip
		REM SET SearchDay=Monday - This would set the SearchDay variables to Monday's date (NONE) will skip
		REM CALL C:\DateTimeCommands\DateTimeExpanded.cmd - Line used in scripts to call on this script.
			REM ECHO any of these values in scripts
			REM Current  - yyyy mm dd day YearMoDa MoDaYear jdate
			REM Previous - pyyyy pmm pdd pday pYearMoDa pMoDaYear pjdate
			REM Search --- syyyy smm sdd sday sYearMoDa sMoDaYear sjdate
			REM FirstDay - fyyyy fmm fdd fday fYearMoDa fMoDaYear fjdate
			REM LastDay  - lyyyy lmm ldd lday lYearMoDa lMoDaYear ljdate
			REM ExactDay - eyyyy emm edd eday eYearMoDa eMoDaYear ejdate
REM ========================================================================================================================================================

::Pull Current Date
CALL C:\Procedures\DateTimeCommands\GetDate.cmd
	SET YearMoDa=%yyyy%%mm%%dd%
	SET YearMoDa=%YearMoDa:~0,8%
	SET MoDaYear=%mm%%dd%%yyyy%
	SET MoDaYear=%MoDaYear:~0,8%

::Override Current date and pretend it is todays date minus the Override value
IF %OVERRIDE%==NONE GOTO :OverRideSkip
CALL C:\Procedures\DateTimeCommands\jDate.cmd OD %yyyy% %mm% %dd%
SET odate=%OD%
SET /A odate=%OD% - %OVERRIDE%
	CALL C:\Procedures\DateTimeCommands\gDate.cmd %odate% yyyy mm dd
	SET YearMoDa=%yyyy%%mm%%dd%
	SET YearMoDa=%YearMoDa:~0,8%
	SET MoDaYear=%mm%%dd%%yyyy%
	SET MoDaYear=%MoDaYear:~0,8%
	SET /A Day=( %odate% +1 ) %% 7
	IF %Day%==0 SET day=Sunday
	IF %Day%==1 SET day=Monday
	IF %Day%==2 SET day=Tuesday
	IF %Day%==3 SET day=Wednesday
	IF %Day%==4 SET day=Thursday
	IF %Day%==5 SET day=Friday
	IF %Day%==6 SET day=Saturday

:OverRideSkip
::Pull Julian Date and pass to all variables
CALL C:\Procedures\DateTimeCommands\jDate.cmd JD %yyyy% %mm% %dd%
	SET jdate=%JD%
	SET pjdate=%JD%
	SET sjdate=%JD%
	SET fjdate=%JD%
	SET ljdate=%JD%
	SET ejdate=%JD%

::Skips Previous Day calulation if SubtractDay set to NONE in calling script
::Calculate the Previous Day
	If %SubtractDay%==NONE Goto :DaySearch
	::Calculate Previous Julian Date and Previous Day DOW
	SET /A pjdate=%pjdate% - %SubtractDay%
	SET /A pDOW=( %pjdate% +1 ) %% 7
	IF %pDOW%==0 SET pday=Sunday
	IF %pDOW%==1 SET pday=Monday
	IF %pDOW%==2 SET pday=Tuesday
	IF %pDOW%==3 SET pday=Wednesday
	IF %pDOW%==4 SET pday=Thursday
	IF %pDOW%==5 SET pday=Friday
	IF %pDOW%==6 SET pday=Saturday

	::Convert Previous Julian Date into Date Format
	CALL C:\Procedures\DateTimeCommands\gDate.cmd %pjdate% pyyyy pmm pdd
	SET pYearMoDa=%pyyyy%%pmm%%pdd%
	SET pYearMoDa=%pYearMoDa:~0,8%
	SET pMoDaYear=%pmm%%pdd%%pyyyy%
	SET pMoDaYear=%pMoDaYear:~0,8%

::Skips Day Search if SearchDay is set to none in calling script
::Calculate the Search Day
:DaySearch
	IF %SearchDay%==NONE GOTO :FirstOfMonth
	::Calculate Search Day Julian Date
	SET sday=%SearchDay%
	SET /A sDOW=( %sjdate% +1 ) %% 7
	SET /A sjdate=%sjdate% - %sDOW%

	::Calculate 
	IF %SearchDay%==Sunday GOTO :Sunday
	IF %SearchDay%==Monday GOTO :Monday
	IF %SearchDay%==Tuesday GOTO :Tuesday
	IF %SearchDay%==Wednesday GOTO :Wednesday
	IF %SearchDay%==Thursday GOTO :Thursday
	IF %SearchDay%==Friday GOTO :Friday
	IF %SearchDay%==Saturday GOTO :Saturday

	:Sunday
	IF %day%==Sunday SET /A sjdate=%sjdate% - 7
	SET /A sjdate=%sjdate + 0
	GOTO :SearchDateContinue
	:Monday
	IF %day%==Monday SET /A sjdate=%sjdate% - 7
	SET /A sjdate=%sjdate + 1
	GOTO :SearchDateContinue
	:Tuesday
	IF %day%==Tuesday SET /A sjdate=%sjdate% - 7
	SET /A sjdate=%sjdate + 2
	GOTO :SearchDateContinue
	:Wednesday
	IF %day%==Wednesday SET /A sjdate=%sjdate% - 7
	SET /A sjdate=%sjdate + 3
	GOTO :SearchDateContinue
	:Thursday
	IF %day%==Thursday SET /A sjdate=%sjdate% - 7
	SET /A sjdate=%sjdate + 4
	GOTO :SearchDateContinue
	:Friday
	IF %day%==Friday SET /A sjdate=%sjdate% - 7
	SET /A sjdate=%sjdate + 5
	GOTO :SearchDateContinue
	:Saturday
	IF %day%==Saturday SET /A sjdate=%sjdate% - 7
	SET /A sjdate=%sjdate + 6

	::Convert Search Day Julian Date into Date Format
	:SearchDateContinue
	CALL C:\Procedures\DateTimeCommands\gDate.cmd %sjdate% syyyy smm sdd
	SET sYearMoDa=%syyyy%%smm%%sdd%
	SET sYearMoDa=%sYearMoDa:~0,8%
	SET sMoDaYear=%smm%%sdd%%syyyy%
	SET sMoDaYear=%sMoDaYear:~0,8%

::Calculate the first day of current month
:FirstOfMonth
	::OMG today is the first day no overtime today
	IF %dd%==01 (Set fYearMoDa=%YearMoDa%
		SET fyyyy=%yyyy%
		SET fmm=%mm%
		SET fdd=%dd%
		SET fDOW=%Day%
		GOTO :EndOfMonth
		)
	::Pull in todays date to the firstday variables
	CALL C:\Procedures\DateTimeCommands\gDate.cmd %fjdate% fyyyy fmm fdd
	
	::Loop through until fdd equals 01
	IF %fdd%==01 GOTO :fSetDate
	SET /A fjdate=(%fjdate% -1)
	IF %fdd% NEQ 01 GOTO :FirstOfMonth
	
	::Set First Day into Date Format
	:fSetDate
	SET fYearMoDa=!fyyyy!!fmm!!fdd!
	SET fYearMoDa=!fYearMoDa:~0,8!
	SET fMoDaYear=!fmm!!fdd!!fyyyy!
	SET fMoDaYear=!fMoDaYear:~0,8!

	::Calculate First Day DOW
	SET /A fDOW=( %fjdate% +1 ) %% 7
	IF %fDOW%==0 SET fday=Sunday
	IF %fDOW%==1 SET fday=Monday
	IF %fDOW%==2 SET fday=Tuesday
	IF %fDOW%==3 SET fday=Wednesday
	IF %fDOW%==4 SET fday=Thursday
	IF %fDOW%==5 SET fday=Friday
	IF %fDOW%==6 SET fday=Saturday

::Calculate the last day of current month
:EndOfMonth
	::Add a day to the current julian date
	SET /A ljdate=(%ljdate% +1)
	
	::Loop Through until fdd equals 01
	:EndOfMonthFound
	::Pull in todays date to the lastday variables
	CALL C:\Procedures\DateTimeCommands\gDate.cmd %ljdate% lyyyy lmm ldd
	IF %ldd%==01 GOTO :lSetDate
	GOTO :EndOfMonth

	::Substract a day now that we found the 1st day of next month to get the last day of current month
	:lSetDate
	SET /A ljdate=(%ljdate% -1)
	
	::Convert Last Day Julian Date into Date Format
	CALL C:\Procedures\DateTimeCommands\gDate.cmd %ljdate% lyyyy lmm ldd
	SET lYearMoDa=!lyyyy!!lmm!!ldd!
	SET lYearMoDa=!lYearMoDa:~0,8!
	SET lMoDaYear=!lmm!!ldd!!lyyyy!
	SET lMoDaYear=!lMoDaYear:~0,8!

	::Calculate Last Day DOW
	SET /A lDOW=( %ljdate% +1 ) %% 7
	IF %lDOW%==0 SET lday=Sunday
	IF %lDOW%==1 SET lday=Monday
	IF %lDOW%==2 SET lday=Tuesday
	IF %lDOW%==3 SET lday=Wednesday
	IF %lDOW%==4 SET lday=Thursday
	IF %lDOW%==5 SET lday=Friday
	IF %lDOW%==6 SET lday=Saturday

::Calculate an exact day of the month
IF %ExactDay%==NONE GOTO :End
:ExactDay
	
	::OMG today is the exact day you want no overtime today
		IF %dd%==%ExactDay% (Set eYearMoDa=%YearMoDa%
		SET eyyyy=%yyyy%
		SET emm=%mm%
		SET edd=%dd%
		SET eDOW=%Day%
		GOTO :eSetDate
		)

	:Try looking down first for a day match
	SET /A ejdate=(%ejdate% -1)
	CALL C:\Procedures\DateTimeCommands\gDate.cmd %ejdate% eyyyy emm edd
	IF %edd%==%ExactDay% GOTO :eSetDate
	::Check so see if last day of the previous month was reached 
	IF %edd% GTR %dd% GOTO :eLookUp
	GOTO :ExactDay

	:Try looking up if looking down failed to get a match
	:eLookUp
	SET ejdate=%jdate%	
	SET /A ejdate=(%ejdate% +1)
	CALL C:\Procedures\DateTimeCommands\gDate.cmd %ejdate% eyyyy emm edd
	IF %edd%==%ExactDay% GOTO :eSetDate
	::No match was found set all values to E for Error
	SET eyyyy=EEEE
	SET emm=EE
	SET edd=EE
	SET eYearMoDa=ERROR
	SET eMoDaYear=ERROR
	SET eday=ERROR
	GOTO :End

	:eSetDate
	SET eYearMoDa=!eyyyy!!emm!!edd!
	SET eYearMoDa=!eYearMoDa:~0,8!
	SET eMoDaYear=!emm!!edd!!eyyyy!
	SET eMoDaYear=!eMoDaYear:~0,8!

	::Calculate Last Day DOW
	SET /A eDOW=( %ejdate% +1 ) %% 7
	IF %eDOW%==0 SET eday=Sunday
	IF %eDOW%==1 SET eday=Monday
	IF %eDOW%==2 SET eday=Tuesday
	IF %eDOW%==3 SET eday=Wednesday
	IF %eDOW%==4 SET eday=Thursday
	IF %eDOW%==5 SET eday=Friday
	IF %eDOW%==6 SET eday=Saturday
:End	